#include "scif.h"
#include "video.h"
#include "graph.h"

/*************************************************************************/
/**---------------------------------------------------------------------**/
/**                         MAIN entry POINT                            **/
/**---------------------------------------------------------------------**/
/*************************************************************************/

#define FG	0xffffff

#define FLAG	0x1C
#define ESC 	0x1B
#define FESC	0x1D

extern flush_cache();
extern _start();

int get_char()
{
	unsigned char a;
	a=scif_rec();
	if (a==FLAG) _start();
	if (a==ESC) {
		a=scif_rec();
		if (a==FESC) a=FLAG;
	}
	return a;
}

int main()
{
	unsigned int i,dir,n;
	void (*addr)(void);
	
	init_video();
	cls(0);
	
	//B
	line(  0+20,160, 80+20,160,FG);
	line( 80+20,160,120+20,200,FG);
	line(120+20,200, 80+20,240,FG);
	line( 80+20,240,120+20,280,FG);
	line(120+20,280, 80+20,320,FG);
	line( 80+20,320,  0+20,320,FG);
	line(  0+20,320,  0+20,160,FG);
	line(  0+20,240, 80+20,240,FG);
	//O
	line(160+20,200,200+20,160,FG);
	line(200+20,160,240+20,160,FG);
	line(240+20,160,280+20,200,FG);
	line(280+20,200,280+20,280,FG);
	line(280+20,280,240+20,320,FG);
	line(240+20,320,200+20,320,FG);
	line(200+20,320,160+20,280,FG);
	line(160+20,280,160+20,200,FG);
	//O
	line(160+160+20,200,200+160+20,160,FG);
	line(200+160+20,160,240+160+20,160,FG);
	line(240+160+20,160,280+160+20,200,FG);
	line(280+160+20,200,280+160+20,280,FG);
	line(280+160+20,280,240+160+20,320,FG);
	line(240+160+20,320,200+160+20,320,FG);
	line(200+160+20,320,160+160+20,280,FG);
	line(160+160+20,280,160+160+20,200,FG);
	//T
	line(480+20,160,600+20,160,FG);
	line(540+20,160,540+20,320,FG);

	scif_init(9600);
	for(;;) {
		//synchro: Wait for magic word
		n=0;
		do {
			n<<=8; n|=scif_rec();
		} while (n!=0xff7f551c);
		
		switch(get_char()) {
		case 'I':	scif_send('A');
				break;
				
		case 'U':	//Upload
				dir<<=8; dir|=get_char();
				dir<<=8; dir|=get_char();
				dir<<=8; dir|=get_char();
				dir<<=8; dir|=get_char();
				n<<=8; n|=get_char();
				n<<=8; n|=get_char();
				n<<=8; n|=get_char();
				n<<=8; n|=get_char();
				for (i=n;i;i--) {
					*(unsigned char *)dir=get_char();
					dir++;
				}
				scif_send('O');
				break;
				
		case 'X':	//Execute
				dir<<=8; dir|=get_char();
				dir<<=8; dir|=get_char();
				dir<<=8; dir|=get_char();
				dir<<=8; dir|=get_char();
				flush_cache();
				addr = (void *)dir;
				(*addr)();
								
		case 'S':	//Set baud
				n<<=8; n|=get_char();
				n<<=8; n|=get_char();
				n<<=8; n|=get_char();
				n<<=8; n|=get_char();
				scif_init(n);
				break;
		}
	}
}
